"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from zav.chat_service.api_client import ApiClient, Endpoint as _Endpoint
from zav.chat_service.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from zav.chat_service.model.agent_bundle_form import AgentBundleForm
from zav.chat_service.model.agent_bundle_item import AgentBundleItem
from zav.chat_service.model.agent_bundle_patch import AgentBundlePatch
from zav.chat_service.model.http_validation_error import HTTPValidationError
from zav.chat_service.model.paginated_response_agent_bundle_item import PaginatedResponseAgentBundleItem


class AgentBundlesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_agent_bundle_endpoint = _Endpoint(
            settings={
                'response_type': (AgentBundleItem,),
                'auth': [],
                'endpoint_path': '/agent-bundles',
                'operation_id': 'create_agent_bundle',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                    'agent_bundle_form',
                ],
                'required': [
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                    'agent_bundle_form',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'requester_uuid':
                        (str,),
                    'agent_bundle_form':
                        (AgentBundleForm,),
                },
                'attribute_map': {
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'requester_uuid': 'requester-uuid',
                },
                'location_map': {
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'requester_uuid': 'header',
                    'agent_bundle_form': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.delete_agent_bundle_endpoint = _Endpoint(
            settings={
                'response_type': None,
                'auth': [],
                'endpoint_path': '/agent-bundles/{project}',
                'operation_id': 'delete_agent_bundle',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'project',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                ],
                'required': [
                    'project',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project':
                        (str,),
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'requester_uuid':
                        (str,),
                },
                'attribute_map': {
                    'project': 'project',
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'requester_uuid': 'requester-uuid',
                },
                'location_map': {
                    'project': 'path',
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'requester_uuid': 'header',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.filter_agent_bundle_endpoint = _Endpoint(
            settings={
                'response_type': (PaginatedResponseAgentBundleItem,),
                'auth': [],
                'endpoint_path': '/agent-bundles',
                'operation_id': 'filter_agent_bundle',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                    'project',
                    'agent_names_include',
                    'last_updated_after',
                    'created_after',
                    'page',
                    'page_size',
                ],
                'required': [
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'requester_uuid':
                        (str,),
                    'project':
                        (str,),
                    'agent_names_include':
                        (str,),
                    'last_updated_after':
                        (datetime,),
                    'created_after':
                        (datetime,),
                    'page':
                        (int,),
                    'page_size':
                        (int,),
                },
                'attribute_map': {
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'requester_uuid': 'requester-uuid',
                    'project': 'project',
                    'agent_names_include': 'agent_names_include',
                    'last_updated_after': 'last_updated_after',
                    'created_after': 'created_after',
                    'page': 'page',
                    'page_size': 'page_size',
                },
                'location_map': {
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'requester_uuid': 'header',
                    'project': 'query',
                    'agent_names_include': 'query',
                    'last_updated_after': 'query',
                    'created_after': 'query',
                    'page': 'query',
                    'page_size': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.retrieve_agent_bundle_endpoint = _Endpoint(
            settings={
                'response_type': (AgentBundleItem,),
                'auth': [],
                'endpoint_path': '/agent-bundles/{project}',
                'operation_id': 'retrieve_agent_bundle',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'project',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                ],
                'required': [
                    'project',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project':
                        (str,),
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'requester_uuid':
                        (str,),
                },
                'attribute_map': {
                    'project': 'project',
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'requester_uuid': 'requester-uuid',
                },
                'location_map': {
                    'project': 'path',
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'requester_uuid': 'header',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.update_agent_bundle_endpoint = _Endpoint(
            settings={
                'response_type': None,
                'auth': [],
                'endpoint_path': '/agent-bundles/{project}',
                'operation_id': 'update_agent_bundle',
                'http_method': 'PATCH',
                'servers': None,
            },
            params_map={
                'all': [
                    'project',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                    'agent_bundle_patch',
                ],
                'required': [
                    'project',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                    'agent_bundle_patch',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project':
                        (str,),
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'requester_uuid':
                        (str,),
                    'agent_bundle_patch':
                        (AgentBundlePatch,),
                },
                'attribute_map': {
                    'project': 'project',
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'requester_uuid': 'requester-uuid',
                },
                'location_map': {
                    'project': 'path',
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'requester_uuid': 'header',
                    'agent_bundle_patch': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def create_agent_bundle(
        self,
        tenant,
        user_roles,
        user_tenants,
        requester_uuid,
        agent_bundle_form,
        **kwargs
    ):
        """Create Agent Bundle  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_agent_bundle(tenant, user_roles, user_tenants, requester_uuid, agent_bundle_form, async_req=True)
        >>> result = thread.get()

        Args:
            tenant (str):
            user_roles (str):
            user_tenants (str):
            requester_uuid (str):
            agent_bundle_form (AgentBundleForm):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            AgentBundleItem
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['tenant'] = \
            tenant
        kwargs['user_roles'] = \
            user_roles
        kwargs['user_tenants'] = \
            user_tenants
        kwargs['requester_uuid'] = \
            requester_uuid
        kwargs['agent_bundle_form'] = \
            agent_bundle_form
        return self.create_agent_bundle_endpoint.call_with_http_info(**kwargs)

    def delete_agent_bundle(
        self,
        project,
        tenant,
        user_roles,
        user_tenants,
        requester_uuid,
        **kwargs
    ):
        """Delete Agent Bundle  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_agent_bundle(project, tenant, user_roles, user_tenants, requester_uuid, async_req=True)
        >>> result = thread.get()

        Args:
            project (str):
            tenant (str):
            user_roles (str):
            user_tenants (str):
            requester_uuid (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['project'] = \
            project
        kwargs['tenant'] = \
            tenant
        kwargs['user_roles'] = \
            user_roles
        kwargs['user_tenants'] = \
            user_tenants
        kwargs['requester_uuid'] = \
            requester_uuid
        return self.delete_agent_bundle_endpoint.call_with_http_info(**kwargs)

    def filter_agent_bundle(
        self,
        tenant,
        user_roles,
        user_tenants,
        requester_uuid,
        **kwargs
    ):
        """Filter Agent Bundle  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.filter_agent_bundle(tenant, user_roles, user_tenants, requester_uuid, async_req=True)
        >>> result = thread.get()

        Args:
            tenant (str):
            user_roles (str):
            user_tenants (str):
            requester_uuid (str):

        Keyword Args:
            project (str): [optional]
            agent_names_include (str): [optional]
            last_updated_after (datetime): [optional]
            created_after (datetime): [optional]
            page (int): [optional] if omitted the server will use the default value of 1
            page_size (int): [optional] if omitted the server will use the default value of 100
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PaginatedResponseAgentBundleItem
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['tenant'] = \
            tenant
        kwargs['user_roles'] = \
            user_roles
        kwargs['user_tenants'] = \
            user_tenants
        kwargs['requester_uuid'] = \
            requester_uuid
        return self.filter_agent_bundle_endpoint.call_with_http_info(**kwargs)

    def retrieve_agent_bundle(
        self,
        project,
        tenant,
        user_roles,
        user_tenants,
        requester_uuid,
        **kwargs
    ):
        """Retrieve Agent Bundle  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.retrieve_agent_bundle(project, tenant, user_roles, user_tenants, requester_uuid, async_req=True)
        >>> result = thread.get()

        Args:
            project (str):
            tenant (str):
            user_roles (str):
            user_tenants (str):
            requester_uuid (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            AgentBundleItem
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['project'] = \
            project
        kwargs['tenant'] = \
            tenant
        kwargs['user_roles'] = \
            user_roles
        kwargs['user_tenants'] = \
            user_tenants
        kwargs['requester_uuid'] = \
            requester_uuid
        return self.retrieve_agent_bundle_endpoint.call_with_http_info(**kwargs)

    def update_agent_bundle(
        self,
        project,
        tenant,
        user_roles,
        user_tenants,
        requester_uuid,
        agent_bundle_patch,
        **kwargs
    ):
        """Update Agent Bundle  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_agent_bundle(project, tenant, user_roles, user_tenants, requester_uuid, agent_bundle_patch, async_req=True)
        >>> result = thread.get()

        Args:
            project (str):
            tenant (str):
            user_roles (str):
            user_tenants (str):
            requester_uuid (str):
            agent_bundle_patch (AgentBundlePatch):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['project'] = \
            project
        kwargs['tenant'] = \
            tenant
        kwargs['user_roles'] = \
            user_roles
        kwargs['user_tenants'] = \
            user_tenants
        kwargs['requester_uuid'] = \
            requester_uuid
        kwargs['agent_bundle_patch'] = \
            agent_bundle_patch
        return self.update_agent_bundle_endpoint.call_with_http_info(**kwargs)

