"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from zav.chat_service.api_client import ApiClient, Endpoint as _Endpoint
from zav.chat_service.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from zav.chat_service.model.agent_tasks_batch_form import AgentTasksBatchForm
from zav.chat_service.model.agent_tasks_batch_item import AgentTasksBatchItem
from zav.chat_service.model.http_validation_error import HTTPValidationError
from zav.chat_service.model.paginated_response_agent_task_item import PaginatedResponseAgentTaskItem


class AgentTasksApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_batch_agent_tasks_endpoint = _Endpoint(
            settings={
                'response_type': (AgentTasksBatchItem,),
                'auth': [],
                'endpoint_path': '/agent-tasks/batch',
                'operation_id': 'create_batch_agent_tasks',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                    'agent_tasks_batch_form',
                    'index_id',
                    'authorization',
                    'x_auth',
                ],
                'required': [
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                    'agent_tasks_batch_form',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'requester_uuid':
                        (str,),
                    'agent_tasks_batch_form':
                        (AgentTasksBatchForm,),
                    'index_id':
                        (str,),
                    'authorization':
                        (str,),
                    'x_auth':
                        (str,),
                },
                'attribute_map': {
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'requester_uuid': 'requester-uuid',
                    'index_id': 'index_id',
                    'authorization': 'Authorization',
                    'x_auth': 'X-Auth',
                },
                'location_map': {
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'requester_uuid': 'header',
                    'agent_tasks_batch_form': 'body',
                    'index_id': 'query',
                    'authorization': 'header',
                    'x_auth': 'header',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.delete_batch_agent_tasks_endpoint = _Endpoint(
            settings={
                'response_type': None,
                'auth': [],
                'endpoint_path': '/agent-tasks/batch/{batch_id}',
                'operation_id': 'delete_batch_agent_tasks',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'batch_id',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                ],
                'required': [
                    'batch_id',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'batch_id':
                        (str,),
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'requester_uuid':
                        (str,),
                },
                'attribute_map': {
                    'batch_id': 'batch_id',
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'requester_uuid': 'requester-uuid',
                },
                'location_map': {
                    'batch_id': 'path',
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'requester_uuid': 'header',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.filter_batch_agent_tasks_endpoint = _Endpoint(
            settings={
                'response_type': (PaginatedResponseAgentTaskItem,),
                'auth': [],
                'endpoint_path': '/agent-tasks/batch/{batch_id}',
                'operation_id': 'filter_batch_agent_tasks',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'batch_id',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                    'last_updated_after',
                    'created_after',
                    'page',
                    'page_size',
                ],
                'required': [
                    'batch_id',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                    'requester_uuid',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'batch_id':
                        (str,),
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'requester_uuid':
                        (str,),
                    'last_updated_after':
                        (datetime,),
                    'created_after':
                        (datetime,),
                    'page':
                        (int,),
                    'page_size':
                        (int,),
                },
                'attribute_map': {
                    'batch_id': 'batch_id',
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'requester_uuid': 'requester-uuid',
                    'last_updated_after': 'last_updated_after',
                    'created_after': 'created_after',
                    'page': 'page',
                    'page_size': 'page_size',
                },
                'location_map': {
                    'batch_id': 'path',
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'requester_uuid': 'header',
                    'last_updated_after': 'query',
                    'created_after': 'query',
                    'page': 'query',
                    'page_size': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def create_batch_agent_tasks(
        self,
        tenant,
        user_roles,
        user_tenants,
        requester_uuid,
        agent_tasks_batch_form,
        **kwargs
    ):
        """Create Batch Agent Tasks  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_batch_agent_tasks(tenant, user_roles, user_tenants, requester_uuid, agent_tasks_batch_form, async_req=True)
        >>> result = thread.get()

        Args:
            tenant (str):
            user_roles (str):
            user_tenants (str):
            requester_uuid (str):
            agent_tasks_batch_form (AgentTasksBatchForm):

        Keyword Args:
            index_id (str): [optional]
            authorization (str): [optional]
            x_auth (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            AgentTasksBatchItem
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['tenant'] = \
            tenant
        kwargs['user_roles'] = \
            user_roles
        kwargs['user_tenants'] = \
            user_tenants
        kwargs['requester_uuid'] = \
            requester_uuid
        kwargs['agent_tasks_batch_form'] = \
            agent_tasks_batch_form
        return self.create_batch_agent_tasks_endpoint.call_with_http_info(**kwargs)

    def delete_batch_agent_tasks(
        self,
        batch_id,
        tenant,
        user_roles,
        user_tenants,
        requester_uuid,
        **kwargs
    ):
        """Delete Batch Agent Tasks  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_batch_agent_tasks(batch_id, tenant, user_roles, user_tenants, requester_uuid, async_req=True)
        >>> result = thread.get()

        Args:
            batch_id (str):
            tenant (str):
            user_roles (str):
            user_tenants (str):
            requester_uuid (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['batch_id'] = \
            batch_id
        kwargs['tenant'] = \
            tenant
        kwargs['user_roles'] = \
            user_roles
        kwargs['user_tenants'] = \
            user_tenants
        kwargs['requester_uuid'] = \
            requester_uuid
        return self.delete_batch_agent_tasks_endpoint.call_with_http_info(**kwargs)

    def filter_batch_agent_tasks(
        self,
        batch_id,
        tenant,
        user_roles,
        user_tenants,
        requester_uuid,
        **kwargs
    ):
        """Filter Batch Agent Tasks  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.filter_batch_agent_tasks(batch_id, tenant, user_roles, user_tenants, requester_uuid, async_req=True)
        >>> result = thread.get()

        Args:
            batch_id (str):
            tenant (str):
            user_roles (str):
            user_tenants (str):
            requester_uuid (str):

        Keyword Args:
            last_updated_after (datetime): [optional]
            created_after (datetime): [optional]
            page (int): [optional] if omitted the server will use the default value of 1
            page_size (int): [optional] if omitted the server will use the default value of 100
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PaginatedResponseAgentTaskItem
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['batch_id'] = \
            batch_id
        kwargs['tenant'] = \
            tenant
        kwargs['user_roles'] = \
            user_roles
        kwargs['user_tenants'] = \
            user_tenants
        kwargs['requester_uuid'] = \
            requester_uuid
        return self.filter_batch_agent_tasks_endpoint.call_with_http_info(**kwargs)

