"""
    Search

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: latest
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from zav.search_api.api_client import ApiClient, Endpoint as _Endpoint
from zav.search_api.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from zav.search_api.model.document_asset_response import DocumentAssetResponse
from zav.search_api.model.document_id_string import DocumentIdString
from zav.search_api.model.guid_string import GUIDString
from zav.search_api.model.generic_error import GenericError
from zav.search_api.model.uuid_string import UUIDString


class DocumentAssetsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.retrieve_endpoint = _Endpoint(
            settings={
                'response_type': (DocumentAssetResponse,),
                'auth': [],
                'endpoint_path': '/document-assets/{guid}/{asset_type}',
                'operation_id': 'retrieve',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'guid',
                    'asset_type',
                    'requester_uuid',
                    'index_cluster',
                    'tenant',
                ],
                'required': [
                    'guid',
                    'asset_type',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'index_cluster',
                ]
            },
            root_map={
                'validations': {
                    ('index_cluster',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]+:[a-zA-Z0-9-_]+$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'guid':
                        (GUIDString,),
                    'asset_type':
                        (str,),
                    'requester_uuid':
                        (UUIDString,),
                    'index_cluster':
                        (str,),
                    'tenant':
                        (str,),
                },
                'attribute_map': {
                    'guid': 'guid',
                    'asset_type': 'asset_type',
                    'requester_uuid': 'requester-uuid',
                    'index_cluster': 'index_cluster',
                    'tenant': 'tenant',
                },
                'location_map': {
                    'guid': 'path',
                    'asset_type': 'path',
                    'requester_uuid': 'header',
                    'index_cluster': 'query',
                    'tenant': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.retrieve_content_endpoint = _Endpoint(
            settings={
                'response_type': (file_type,),
                'auth': [],
                'endpoint_path': '/document-assets/{document_id}/{asset_type}/content',
                'operation_id': 'retrieve_content',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'document_id',
                    'asset_type',
                    'requester_uuid',
                    'index_cluster',
                    'tenant',
                    'user_roles',
                    'user_tenants',
                ],
                'required': [
                    'document_id',
                    'asset_type',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'index_cluster',
                ]
            },
            root_map={
                'validations': {
                    ('index_cluster',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]+:[a-zA-Z0-9-_]+$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'document_id':
                        (DocumentIdString,),
                    'asset_type':
                        (str,),
                    'requester_uuid':
                        (UUIDString,),
                    'index_cluster':
                        (str,),
                    'tenant':
                        (str,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                },
                'attribute_map': {
                    'document_id': 'document_id',
                    'asset_type': 'asset_type',
                    'requester_uuid': 'requester-uuid',
                    'index_cluster': 'index_cluster',
                    'tenant': 'tenant',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                },
                'location_map': {
                    'document_id': 'path',
                    'asset_type': 'path',
                    'requester_uuid': 'header',
                    'index_cluster': 'query',
                    'tenant': 'query',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/pdf',
                    'image/jpeg',
                    'image/png',
                    'text/plain',
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def retrieve(
        self,
        guid,
        asset_type,
        **kwargs
    ):
        """Return asset for the selected document guid.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.retrieve(guid, asset_type, async_req=True)
        >>> result = thread.get()

        Args:
            guid (GUIDString):
            asset_type (str): Return document asset of the specified type.

        Keyword Args:
            requester_uuid (UUIDString): [optional]
            index_cluster (str): Human friendly name that specifies which index configuration to use during search. The way we convert this string into infrastructure configuration is part of the internal logic of this service. Ideally all possible values should be listed as part of another request along with the description of what each value means.  Currently, the value can be constructed by using knowledge of the index infrastructure. In particular, the value is separated by the `:` character. The part on the left of `:` represents the kubernetes namespace of the index cluster, while the part on the right specifies the infix in the index name.  For example, if a user wants to search in the index cluster located in the `foo` namespace and use the index named `my_tenant_bar_documents`, then the `index_cluster` value should be `foo:bar`. The user may also need to specify the retrieval unit and tenant as part of the request.  > Note: There's currently no endpoint for retrieving all valid values that the `index_cluster` parameter can take. . [optional]
            tenant (str): Tenant. [optional] if omitted the server will use the default value of "zetaalpha"
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            DocumentAssetResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['guid'] = \
            guid
        kwargs['asset_type'] = \
            asset_type
        return self.retrieve_endpoint.call_with_http_info(**kwargs)

    def retrieve_content(
        self,
        document_id,
        asset_type,
        **kwargs
    ):
        """Return asset content for the selected document document_id.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.retrieve_content(document_id, asset_type, async_req=True)
        >>> result = thread.get()

        Args:
            document_id (DocumentIdString):
            asset_type (str): Return document asset of the specified type.

        Keyword Args:
            requester_uuid (UUIDString): [optional]
            index_cluster (str): Human friendly name that specifies which index configuration to use during search. The way we convert this string into infrastructure configuration is part of the internal logic of this service. Ideally all possible values should be listed as part of another request along with the description of what each value means.  Currently, the value can be constructed by using knowledge of the index infrastructure. In particular, the value is separated by the `:` character. The part on the left of `:` represents the kubernetes namespace of the index cluster, while the part on the right specifies the infix in the index name.  For example, if a user wants to search in the index cluster located in the `foo` namespace and use the index named `my_tenant_bar_documents`, then the `index_cluster` value should be `foo:bar`. The user may also need to specify the retrieval unit and tenant as part of the request.  > Note: There's currently no endpoint for retrieving all valid values that the `index_cluster` parameter can take. . [optional]
            tenant (str): Tenant. [optional] if omitted the server will use the default value of "zetaalpha"
            user_roles (str): [optional]
            user_tenants (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            file_type
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['document_id'] = \
            document_id
        kwargs['asset_type'] = \
            asset_type
        return self.retrieve_content_endpoint.call_with_http_info(**kwargs)

