"""
    Search

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: latest
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from zav.search_api.api_client import ApiClient, Endpoint as _Endpoint
from zav.search_api.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from zav.search_api.model.date_range_schema import DateRangeSchema
from zav.search_api.model.guid_string import GUIDString
from zav.search_api.model.generic_error import GenericError
from zav.search_api.model.list_response import ListResponse
from zav.search_api.model.query_string import QueryString
from zav.search_api.model.search_engine_string import SearchEngineString
from zav.search_api.model.search_post_request import SearchPostRequest
from zav.search_api.model.search_post_response import SearchPostResponse
from zav.search_api.model.search_response import SearchResponse
from zav.search_api.model.sort1 import Sort1
from zav.search_api.model.uid_string import UIDString
from zav.search_api.model.uuid_string import UUIDString
from zav.search_api.model.year_range_schema import YearRangeSchema


class DocumentsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.document_count_endpoint = _Endpoint(
            settings={
                'response_type': (int,),
                'auth': [],
                'endpoint_path': '/documents/{retrieval_unit}/count',
                'operation_id': 'document_count',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'retrieval_unit',
                    'requester_uuid',
                    'user_roles',
                    'tenant',
                    'query_string',
                    'retrieval_method',
                    'year',
                    'sources',
                    'cited_by',
                    'cites',
                    'authored_by',
                    'date',
                    'doc_ids',
                    'tag_ids',
                    'has_concept',
                    'with_content',
                    'include_default_filters',
                    'document_types',
                    'with_code',
                    'index_cluster',
                    'visibility',
                    'location_cities',
                    'location_countries',
                    'organizations',
                ],
                'required': [
                    'retrieval_unit',
                ],
                'nullable': [
                ],
                'enum': [
                    'retrieval_unit',
                    'retrieval_method',
                    'document_types',
                ],
                'validation': [
                    'index_cluster',
                ]
            },
            root_map={
                'validations': {
                    ('index_cluster',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]+:[a-zA-Z0-9-_]+$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                    ('retrieval_unit',): {

                        "DOCUMENT": "document",
                        "CHUNK": "chunk",
                        "SENTENCE": "sentence"
                    },
                    ('retrieval_method',): {

                        "KNN": "knn",
                        "KEYWORD": "keyword",
                        "MIXED": "mixed"
                    },
                    ('document_types',): {

                        "DOCUMENT": "document",
                        "CITATION": "citation",
                        "NOTE": "note"
                    },
                },
                'openapi_types': {
                    'retrieval_unit':
                        (str,),
                    'requester_uuid':
                        (UUIDString,),
                    'user_roles':
                        (str,),
                    'tenant':
                        (str,),
                    'query_string':
                        (QueryString,),
                    'retrieval_method':
                        (str,),
                    'year':
                        (YearRangeSchema,),
                    'sources':
                        ([str],),
                    'cited_by':
                        (str,),
                    'cites':
                        (str,),
                    'authored_by':
                        (str,),
                    'date':
                        (DateRangeSchema,),
                    'doc_ids':
                        ([GUIDString],),
                    'tag_ids':
                        ([str],),
                    'has_concept':
                        (str,),
                    'with_content':
                        (bool,),
                    'include_default_filters':
                        (bool,),
                    'document_types':
                        ([str],),
                    'with_code':
                        (bool,),
                    'index_cluster':
                        (str,),
                    'visibility':
                        ([str],),
                    'location_cities':
                        ([str],),
                    'location_countries':
                        ([str],),
                    'organizations':
                        ([str],),
                },
                'attribute_map': {
                    'retrieval_unit': 'retrieval_unit',
                    'requester_uuid': 'requester-uuid',
                    'user_roles': 'user-roles',
                    'tenant': 'tenant',
                    'query_string': 'query_string',
                    'retrieval_method': 'retrieval_method',
                    'year': 'year',
                    'sources': 'sources',
                    'cited_by': 'cited_by',
                    'cites': 'cites',
                    'authored_by': 'authored_by',
                    'date': 'date',
                    'doc_ids': 'doc_ids',
                    'tag_ids': 'tag_ids',
                    'has_concept': 'has_concept',
                    'with_content': 'with_content',
                    'include_default_filters': 'include_default_filters',
                    'document_types': 'document_types',
                    'with_code': 'with_code',
                    'index_cluster': 'index_cluster',
                    'visibility': 'visibility',
                    'location_cities': 'location_cities',
                    'location_countries': 'location_countries',
                    'organizations': 'organizations',
                },
                'location_map': {
                    'retrieval_unit': 'path',
                    'requester_uuid': 'header',
                    'user_roles': 'header',
                    'tenant': 'query',
                    'query_string': 'query',
                    'retrieval_method': 'query',
                    'year': 'query',
                    'sources': 'query',
                    'cited_by': 'query',
                    'cites': 'query',
                    'authored_by': 'query',
                    'date': 'query',
                    'doc_ids': 'query',
                    'tag_ids': 'query',
                    'has_concept': 'query',
                    'with_content': 'query',
                    'include_default_filters': 'query',
                    'document_types': 'query',
                    'with_code': 'query',
                    'index_cluster': 'query',
                    'visibility': 'query',
                    'location_cities': 'query',
                    'location_countries': 'query',
                    'organizations': 'query',
                },
                'collection_format_map': {
                    'sources': 'csv',
                    'doc_ids': 'csv',
                    'tag_ids': 'csv',
                    'document_types': 'csv',
                    'visibility': 'csv',
                    'location_cities': 'csv',
                    'location_countries': 'csv',
                    'organizations': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.document_list_endpoint = _Endpoint(
            settings={
                'response_type': (ListResponse,),
                'auth': [],
                'endpoint_path': '/documents/{retrieval_unit}/list',
                'operation_id': 'document_list',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'retrieval_unit',
                    'property_name',
                    'property_values',
                    'requester_uuid',
                    'user_roles',
                    'user_tenants',
                    'tenant',
                    'page',
                    'page_size',
                    'collapse',
                    'index_cluster',
                    'requested_field_paths',
                ],
                'required': [
                    'retrieval_unit',
                    'property_name',
                    'property_values',
                ],
                'nullable': [
                    'collapse',
                ],
                'enum': [
                    'retrieval_unit',
                    'property_name',
                    'collapse',
                ],
                'validation': [
                    'page',
                    'page_size',
                    'index_cluster',
                ]
            },
            root_map={
                'validations': {
                    ('page',): {

                        'inclusive_minimum': 0,
                    },
                    ('page_size',): {

                        'inclusive_minimum': 1,
                    },
                    ('index_cluster',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]+:[a-zA-Z0-9-_]+$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                    ('retrieval_unit',): {

                        "DOCUMENT": "document",
                        "CHUNK": "chunk",
                        "SENTENCE": "sentence"
                    },
                    ('property_name',): {

                        "ID": "id",
                        "UID": "uid",
                        "GUID": "guid",
                        "ORGANIZE_DOC_ID": "organize_doc_id"
                    },
                    ('collapse',): {
                        'None': None,
                        "UID": "uid",
                        "NULL": "null"
                    },
                },
                'openapi_types': {
                    'retrieval_unit':
                        (str,),
                    'property_name':
                        (str,),
                    'property_values':
                        ([str],),
                    'requester_uuid':
                        (UUIDString,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'tenant':
                        (str,),
                    'page':
                        (int,),
                    'page_size':
                        (int,),
                    'collapse':
                        (str, none_type,),
                    'index_cluster':
                        (str,),
                    'requested_field_paths':
                        ([str],),
                },
                'attribute_map': {
                    'retrieval_unit': 'retrieval_unit',
                    'property_name': 'property_name',
                    'property_values': 'property_values',
                    'requester_uuid': 'requester-uuid',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                    'tenant': 'tenant',
                    'page': 'page',
                    'page_size': 'page_size',
                    'collapse': 'collapse',
                    'index_cluster': 'index_cluster',
                    'requested_field_paths': 'requested_field_paths',
                },
                'location_map': {
                    'retrieval_unit': 'path',
                    'property_name': 'query',
                    'property_values': 'query',
                    'requester_uuid': 'header',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'tenant': 'query',
                    'page': 'query',
                    'page_size': 'query',
                    'collapse': 'query',
                    'index_cluster': 'query',
                    'requested_field_paths': 'query',
                },
                'collection_format_map': {
                    'property_values': 'csv',
                    'requested_field_paths': 'multi',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.document_search_endpoint = _Endpoint(
            settings={
                'response_type': (SearchResponse,),
                'auth': [],
                'endpoint_path': '/documents/{retrieval_unit}/search',
                'operation_id': 'document_search',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'retrieval_unit',
                    'requester_uuid',
                    'user_roles',
                    'tenant',
                    'search_engine',
                    'query_string',
                    'retrieval_method',
                    'year',
                    'sources',
                    'cited_by',
                    'cites',
                    'authored_by',
                    'date',
                    'doc_ids',
                    'tag_ids',
                    'has_concept',
                    'with_content',
                    'include_default_filters',
                    'document_types',
                    'page',
                    'page_size',
                    'sort',
                    'sort_order',
                    'similar_to',
                    'collapse',
                    'rerank',
                    'rerank_top_n',
                    'aggregate_reranked_results',
                    'simplified_query',
                    'with_code',
                    'index_cluster',
                    'visibility',
                    'location_cities',
                    'location_countries',
                    'organizations',
                ],
                'required': [
                    'retrieval_unit',
                ],
                'nullable': [
                    'collapse',
                ],
                'enum': [
                    'retrieval_unit',
                    'retrieval_method',
                    'document_types',
                    'sort_order',
                    'collapse',
                ],
                'validation': [
                    'page',
                    'page_size',
                    'index_cluster',
                ]
            },
            root_map={
                'validations': {
                    ('page',): {

                        'inclusive_minimum': 0,
                    },
                    ('page_size',): {

                        'inclusive_minimum': 1,
                    },
                    ('index_cluster',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]+:[a-zA-Z0-9-_]+$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                    ('retrieval_unit',): {

                        "DOCUMENT": "document",
                        "CHUNK": "chunk",
                        "SENTENCE": "sentence"
                    },
                    ('retrieval_method',): {

                        "KNN": "knn",
                        "KEYWORD": "keyword",
                        "MIXED": "mixed"
                    },
                    ('document_types',): {

                        "DOCUMENT": "document",
                        "CITATION": "citation",
                        "NOTE": "note"
                    },
                    ('sort_order',): {

                        "DATE": "date",
                        "CITATIONS": "citations",
                        "SOURCE": "source",
                        "YEAR": "year",
                        "AUTHORITY": "authority",
                        "POPULARITY": "popularity",
                        "CODE": "code"
                    },
                    ('collapse',): {
                        'None': None,
                        "UID": "uid",
                        "NULL": "null"
                    },
                },
                'openapi_types': {
                    'retrieval_unit':
                        (str,),
                    'requester_uuid':
                        (UUIDString,),
                    'user_roles':
                        (str,),
                    'tenant':
                        (str,),
                    'search_engine':
                        (SearchEngineString,),
                    'query_string':
                        (QueryString,),
                    'retrieval_method':
                        (str,),
                    'year':
                        (YearRangeSchema,),
                    'sources':
                        ([str],),
                    'cited_by':
                        (str,),
                    'cites':
                        (str,),
                    'authored_by':
                        (str,),
                    'date':
                        (DateRangeSchema,),
                    'doc_ids':
                        ([GUIDString],),
                    'tag_ids':
                        ([str],),
                    'has_concept':
                        (str,),
                    'with_content':
                        (bool,),
                    'include_default_filters':
                        (bool,),
                    'document_types':
                        ([str],),
                    'page':
                        (int,),
                    'page_size':
                        (int,),
                    'sort':
                        (Sort1,),
                    'sort_order':
                        ([str],),
                    'similar_to':
                        ([UIDString],),
                    'collapse':
                        (str, none_type,),
                    'rerank':
                        (bool,),
                    'rerank_top_n':
                        (int,),
                    'aggregate_reranked_results':
                        (bool,),
                    'simplified_query':
                        (bool,),
                    'with_code':
                        (bool,),
                    'index_cluster':
                        (str,),
                    'visibility':
                        ([str],),
                    'location_cities':
                        ([str],),
                    'location_countries':
                        ([str],),
                    'organizations':
                        ([str],),
                },
                'attribute_map': {
                    'retrieval_unit': 'retrieval_unit',
                    'requester_uuid': 'requester-uuid',
                    'user_roles': 'user-roles',
                    'tenant': 'tenant',
                    'search_engine': 'search_engine',
                    'query_string': 'query_string',
                    'retrieval_method': 'retrieval_method',
                    'year': 'year',
                    'sources': 'sources',
                    'cited_by': 'cited_by',
                    'cites': 'cites',
                    'authored_by': 'authored_by',
                    'date': 'date',
                    'doc_ids': 'doc_ids',
                    'tag_ids': 'tag_ids',
                    'has_concept': 'has_concept',
                    'with_content': 'with_content',
                    'include_default_filters': 'include_default_filters',
                    'document_types': 'document_types',
                    'page': 'page',
                    'page_size': 'page_size',
                    'sort': 'sort',
                    'sort_order': 'sort_order',
                    'similar_to': 'similar_to',
                    'collapse': 'collapse',
                    'rerank': 'rerank',
                    'rerank_top_n': 'rerank_top_n',
                    'aggregate_reranked_results': 'aggregate_reranked_results',
                    'simplified_query': 'simplified_query',
                    'with_code': 'with_code',
                    'index_cluster': 'index_cluster',
                    'visibility': 'visibility',
                    'location_cities': 'location_cities',
                    'location_countries': 'location_countries',
                    'organizations': 'organizations',
                },
                'location_map': {
                    'retrieval_unit': 'path',
                    'requester_uuid': 'header',
                    'user_roles': 'header',
                    'tenant': 'query',
                    'search_engine': 'query',
                    'query_string': 'query',
                    'retrieval_method': 'query',
                    'year': 'query',
                    'sources': 'query',
                    'cited_by': 'query',
                    'cites': 'query',
                    'authored_by': 'query',
                    'date': 'query',
                    'doc_ids': 'query',
                    'tag_ids': 'query',
                    'has_concept': 'query',
                    'with_content': 'query',
                    'include_default_filters': 'query',
                    'document_types': 'query',
                    'page': 'query',
                    'page_size': 'query',
                    'sort': 'query',
                    'sort_order': 'query',
                    'similar_to': 'query',
                    'collapse': 'query',
                    'rerank': 'query',
                    'rerank_top_n': 'query',
                    'aggregate_reranked_results': 'query',
                    'simplified_query': 'query',
                    'with_code': 'query',
                    'index_cluster': 'query',
                    'visibility': 'query',
                    'location_cities': 'query',
                    'location_countries': 'query',
                    'organizations': 'query',
                },
                'collection_format_map': {
                    'sources': 'csv',
                    'doc_ids': 'csv',
                    'tag_ids': 'csv',
                    'document_types': 'csv',
                    'sort_order': 'csv',
                    'similar_to': 'csv',
                    'visibility': 'csv',
                    'location_cities': 'csv',
                    'location_countries': 'csv',
                    'organizations': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.document_search_post_endpoint = _Endpoint(
            settings={
                'response_type': (SearchPostResponse,),
                'auth': [],
                'endpoint_path': '/documents/search',
                'operation_id': 'document_search_post',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'requester_uuid',
                    'user_roles',
                    'user_tenants',
                    'search_post_request',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'requester_uuid':
                        (UUIDString,),
                    'user_roles':
                        (str,),
                    'user_tenants':
                        (str,),
                    'search_post_request':
                        (SearchPostRequest,),
                },
                'attribute_map': {
                    'requester_uuid': 'requester-uuid',
                    'user_roles': 'user-roles',
                    'user_tenants': 'user-tenants',
                },
                'location_map': {
                    'requester_uuid': 'header',
                    'user_roles': 'header',
                    'user_tenants': 'header',
                    'search_post_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.document_vos_endpoint = _Endpoint(
            settings={
                'response_type': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                'auth': [],
                'endpoint_path': '/documents/document/vos',
                'operation_id': 'document_vos',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'requester_uuid',
                    'user_roles',
                    'tenant',
                    'query_string',
                    'retrieval_method',
                    'year',
                    'sources',
                    'cited_by',
                    'cites',
                    'authored_by',
                    'date',
                    'doc_ids',
                    'tag_ids',
                    'has_concept',
                    'with_content',
                    'include_default_filters',
                    'document_types',
                    'sort',
                    'sort_order',
                    'similar_to',
                    'collapse',
                    'rerank',
                    'rerank_top_n',
                    'aggregate_reranked_results',
                    'vos_size',
                    'with_code',
                    'index_cluster',
                    'visibility',
                    'location_cities',
                    'location_countries',
                    'organizations',
                ],
                'required': [],
                'nullable': [
                    'collapse',
                ],
                'enum': [
                    'retrieval_method',
                    'document_types',
                    'sort_order',
                    'collapse',
                ],
                'validation': [
                    'index_cluster',
                ]
            },
            root_map={
                'validations': {
                    ('index_cluster',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]+:[a-zA-Z0-9-_]+$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                    ('retrieval_method',): {

                        "KNN": "knn",
                        "KEYWORD": "keyword",
                        "MIXED": "mixed"
                    },
                    ('document_types',): {

                        "DOCUMENT": "document",
                        "CITATION": "citation",
                        "NOTE": "note"
                    },
                    ('sort_order',): {

                        "DATE": "date",
                        "CITATIONS": "citations",
                        "SOURCE": "source",
                        "YEAR": "year",
                        "AUTHORITY": "authority",
                        "POPULARITY": "popularity",
                        "CODE": "code"
                    },
                    ('collapse',): {
                        'None': None,
                        "UID": "uid",
                        "NULL": "null"
                    },
                },
                'openapi_types': {
                    'requester_uuid':
                        (UUIDString,),
                    'user_roles':
                        (str,),
                    'tenant':
                        (str,),
                    'query_string':
                        (QueryString,),
                    'retrieval_method':
                        (str,),
                    'year':
                        (YearRangeSchema,),
                    'sources':
                        ([str],),
                    'cited_by':
                        (str,),
                    'cites':
                        (str,),
                    'authored_by':
                        (str,),
                    'date':
                        (DateRangeSchema,),
                    'doc_ids':
                        ([GUIDString],),
                    'tag_ids':
                        ([str],),
                    'has_concept':
                        (str,),
                    'with_content':
                        (bool,),
                    'include_default_filters':
                        (bool,),
                    'document_types':
                        ([str],),
                    'sort':
                        (Sort1,),
                    'sort_order':
                        ([str],),
                    'similar_to':
                        ([UIDString],),
                    'collapse':
                        (str, none_type,),
                    'rerank':
                        (bool,),
                    'rerank_top_n':
                        (int,),
                    'aggregate_reranked_results':
                        (bool,),
                    'vos_size':
                        (int,),
                    'with_code':
                        (bool,),
                    'index_cluster':
                        (str,),
                    'visibility':
                        ([str],),
                    'location_cities':
                        ([str],),
                    'location_countries':
                        ([str],),
                    'organizations':
                        ([str],),
                },
                'attribute_map': {
                    'requester_uuid': 'requester-uuid',
                    'user_roles': 'user-roles',
                    'tenant': 'tenant',
                    'query_string': 'query_string',
                    'retrieval_method': 'retrieval_method',
                    'year': 'year',
                    'sources': 'sources',
                    'cited_by': 'cited_by',
                    'cites': 'cites',
                    'authored_by': 'authored_by',
                    'date': 'date',
                    'doc_ids': 'doc_ids',
                    'tag_ids': 'tag_ids',
                    'has_concept': 'has_concept',
                    'with_content': 'with_content',
                    'include_default_filters': 'include_default_filters',
                    'document_types': 'document_types',
                    'sort': 'sort',
                    'sort_order': 'sort_order',
                    'similar_to': 'similar_to',
                    'collapse': 'collapse',
                    'rerank': 'rerank',
                    'rerank_top_n': 'rerank_top_n',
                    'aggregate_reranked_results': 'aggregate_reranked_results',
                    'vos_size': 'vos_size',
                    'with_code': 'with_code',
                    'index_cluster': 'index_cluster',
                    'visibility': 'visibility',
                    'location_cities': 'location_cities',
                    'location_countries': 'location_countries',
                    'organizations': 'organizations',
                },
                'location_map': {
                    'requester_uuid': 'header',
                    'user_roles': 'header',
                    'tenant': 'query',
                    'query_string': 'query',
                    'retrieval_method': 'query',
                    'year': 'query',
                    'sources': 'query',
                    'cited_by': 'query',
                    'cites': 'query',
                    'authored_by': 'query',
                    'date': 'query',
                    'doc_ids': 'query',
                    'tag_ids': 'query',
                    'has_concept': 'query',
                    'with_content': 'query',
                    'include_default_filters': 'query',
                    'document_types': 'query',
                    'sort': 'query',
                    'sort_order': 'query',
                    'similar_to': 'query',
                    'collapse': 'query',
                    'rerank': 'query',
                    'rerank_top_n': 'query',
                    'aggregate_reranked_results': 'query',
                    'vos_size': 'query',
                    'with_code': 'query',
                    'index_cluster': 'query',
                    'visibility': 'query',
                    'location_cities': 'query',
                    'location_countries': 'query',
                    'organizations': 'query',
                },
                'collection_format_map': {
                    'sources': 'csv',
                    'doc_ids': 'csv',
                    'tag_ids': 'csv',
                    'document_types': 'csv',
                    'sort_order': 'csv',
                    'similar_to': 'csv',
                    'visibility': 'csv',
                    'location_cities': 'csv',
                    'location_countries': 'csv',
                    'organizations': 'csv',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.document_vos_cluster_titles_endpoint = _Endpoint(
            settings={
                'response_type': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                'auth': [],
                'endpoint_path': '/documents/document/vos-cluster-titles',
                'operation_id': 'document_vos_cluster_titles',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'user_roles',
                    'tenant',
                    'body',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'user_roles':
                        (str,),
                    'tenant':
                        (str,),
                    'body':
                        ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
                },
                'attribute_map': {
                    'user_roles': 'user-roles',
                    'tenant': 'tenant',
                },
                'location_map': {
                    'user_roles': 'header',
                    'tenant': 'query',
                    'body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def document_count(
        self,
        retrieval_unit,
        **kwargs
    ):
        """Count the number of documents based on query and parameters  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.document_count(retrieval_unit, async_req=True)
        >>> result = thread.get()

        Args:
            retrieval_unit (str): Retrieval unit

        Keyword Args:
            requester_uuid (UUIDString): [optional]
            user_roles (str): [optional]
            tenant (str): Tenant. [optional] if omitted the server will use the default value of "zetaalpha"
            query_string (QueryString): Query string. [optional]
            retrieval_method (str): Method used for retrieval. [optional] if omitted the server will use the default value of "keyword"
            year (YearRangeSchema): Limit results to those in year range (inclusive). [optional]
            sources ([str]): Limit results to selected sources. [optional]
            cited_by (str): Limit results to only papers cited by the given paper. [optional]
            cites (str): Limit results to only papers cite the given paper. [optional]
            authored_by (str): Limit results to only papers authored by the given person. [optional]
            date (DateRangeSchema): Limit results to those in date range (inclusive). [optional]
            doc_ids ([GUIDString]): Limit results to only the given document IDs. [optional]
            tag_ids ([str]): Limit results to only the given tag IDs. [optional]
            has_concept (str): Limit results to only papers that contain the given concept. [optional]
            with_content (bool): Limit results to only papers that have content (text representation). Note. This doesn't apply to private documents.. [optional] if omitted the server will use the default value of False
            include_default_filters (bool): Filter results based on the default filters configuration of the index.. [optional] if omitted the server will use the default value of True
            document_types ([str]): Limit results to documents with the given type. [optional] if omitted the server will use the default value of ["document"]
            with_code (bool): Output only papers with code.. [optional] if omitted the server will use the default value of False
            index_cluster (str): Human friendly name that specifies which index configuration to use during search. The way we convert this string into infrastructure configuration is part of the internal logic of this service. Ideally all possible values should be listed as part of another request along with the description of what each value means.  Currently, the value can be constructed by using knowledge of the index infrastructure. In particular, the value is separated by the `:` character. The part on the left of `:` represents the kubernetes namespace of the index cluster, while the part on the right specifies the infix in the index name.  For example, if a user wants to search in the index cluster located in the `foo` namespace and use the index named `my_tenant_bar_documents`, then the `index_cluster` value should be `foo:bar`. The user may also need to specify the retrieval unit and tenant as part of the request.  > Note: There's currently no endpoint for retrieving all valid values that the `index_cluster` parameter can take. . [optional]
            visibility ([str]): Filter documents by their visibility.. [optional]
            location_cities ([str]): Limit results to documents of authors located in cities. [optional]
            location_countries ([str]): Limit results to documents of authors located in countries. [optional]
            organizations ([str]): Limit results to documents of authors affiliated with organization. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            int
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['retrieval_unit'] = \
            retrieval_unit
        return self.document_count_endpoint.call_with_http_info(**kwargs)

    def document_list(
        self,
        retrieval_unit,
        property_name,
        property_values,
        **kwargs
    ):
        """List documents based on property values  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.document_list(retrieval_unit, property_name, property_values, async_req=True)
        >>> result = thread.get()

        Args:
            retrieval_unit (str): Retrieval unit
            property_name (str): Property on which to select document(s)
            property_values ([str]): Property value(s)

        Keyword Args:
            requester_uuid (UUIDString): [optional]
            user_roles (str): [optional]
            user_tenants (str): [optional]
            tenant (str): Tenant. [optional] if omitted the server will use the default value of "zetaalpha"
            page (int): Page. [optional] if omitted the server will use the default value of 1
            page_size (int): Page size. [optional] if omitted the server will use the default value of 10
            collapse (str, none_type): Field on which to collapse results. [optional] if omitted the server will use the default value of "uid"
            index_cluster (str): Human friendly name that specifies which index configuration to use during search. The way we convert this string into infrastructure configuration is part of the internal logic of this service. Ideally all possible values should be listed as part of another request along with the description of what each value means.  Currently, the value can be constructed by using knowledge of the index infrastructure. In particular, the value is separated by the `:` character. The part on the left of `:` represents the kubernetes namespace of the index cluster, while the part on the right specifies the infix in the index name.  For example, if a user wants to search in the index cluster located in the `foo` namespace and use the index named `my_tenant_bar_documents`, then the `index_cluster` value should be `foo:bar`. The user may also need to specify the retrieval unit and tenant as part of the request.  > Note: There's currently no endpoint for retrieving all valid values that the `index_cluster` parameter can take. . [optional]
            requested_field_paths ([str]): Requested field paths. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ListResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['retrieval_unit'] = \
            retrieval_unit
        kwargs['property_name'] = \
            property_name
        kwargs['property_values'] = \
            property_values
        return self.document_list_endpoint.call_with_http_info(**kwargs)

    def document_search(
        self,
        retrieval_unit,
        **kwargs
    ):
        """Search documents based on query and parameters  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.document_search(retrieval_unit, async_req=True)
        >>> result = thread.get()

        Args:
            retrieval_unit (str): Retrieval unit

        Keyword Args:
            requester_uuid (UUIDString): [optional]
            user_roles (str): [optional]
            tenant (str): Tenant. [optional] if omitted the server will use the default value of "zetaalpha"
            search_engine (SearchEngineString): Search engine to use. [optional]
            query_string (QueryString): Query string. [optional]
            retrieval_method (str): Method used for retrieval. [optional] if omitted the server will use the default value of "keyword"
            year (YearRangeSchema): Limit results to those in year range (inclusive). [optional]
            sources ([str]): Limit results to selected sources. [optional]
            cited_by (str): Limit results to only papers cited by the given paper. [optional]
            cites (str): Limit results to only papers cite the given paper. [optional]
            authored_by (str): Limit results to only papers authored by the given person. [optional]
            date (DateRangeSchema): Limit results to those in date range (inclusive). [optional]
            doc_ids ([GUIDString]): Limit results to only the given document IDs. [optional]
            tag_ids ([str]): Limit results to only the given tag IDs. [optional]
            has_concept (str): Limit results to only papers that contain the given concept. [optional]
            with_content (bool): Limit results to only papers that have content (text representation). Note. This doesn't apply to private documents.. [optional] if omitted the server will use the default value of False
            include_default_filters (bool): Filter results based on the default filters configuration of the index.. [optional] if omitted the server will use the default value of True
            document_types ([str]): Limit results to documents with the given type. [optional] if omitted the server will use the default value of ["document"]
            page (int): Page. [optional] if omitted the server will use the default value of 1
            page_size (int): Page size. [optional] if omitted the server will use the default value of 10
            sort (Sort1): Sorting parameters.. [optional]
            sort_order ([str]): Order in which to apply sorting parameters. All values from sort should be listed here.. [optional]
            similar_to ([UIDString]): Find documents similar to the list of input documents. [optional]
            collapse (str, none_type): Field on which to collapse results. [optional] if omitted the server will use the default value of "uid"
            rerank (bool): Whether we want to rerank seacrh results.. [optional] if omitted the server will use the default value of False
            rerank_top_n (int): A number of first results to re-rerank.. [optional] if omitted the server will use the default value of 30
            aggregate_reranked_results (bool): Aggregate lower-level units to higher-level ones.. [optional] if omitted the server will use the default value of False
            simplified_query (bool): Generates a simplified elastic query without any boostings related to query terms.. [optional] if omitted the server will use the default value of False
            with_code (bool): Output only papers with code.. [optional] if omitted the server will use the default value of False
            index_cluster (str): Human friendly name that specifies which index configuration to use during search. The way we convert this string into infrastructure configuration is part of the internal logic of this service. Ideally all possible values should be listed as part of another request along with the description of what each value means.  Currently, the value can be constructed by using knowledge of the index infrastructure. In particular, the value is separated by the `:` character. The part on the left of `:` represents the kubernetes namespace of the index cluster, while the part on the right specifies the infix in the index name.  For example, if a user wants to search in the index cluster located in the `foo` namespace and use the index named `my_tenant_bar_documents`, then the `index_cluster` value should be `foo:bar`. The user may also need to specify the retrieval unit and tenant as part of the request.  > Note: There's currently no endpoint for retrieving all valid values that the `index_cluster` parameter can take. . [optional]
            visibility ([str]): Filter documents by their visibility.. [optional]
            location_cities ([str]): Limit results to documents of authors located in cities. [optional]
            location_countries ([str]): Limit results to documents of authors located in countries. [optional]
            organizations ([str]): Limit results to documents of authors affiliated with organization. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            SearchResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['retrieval_unit'] = \
            retrieval_unit
        return self.document_search_endpoint.call_with_http_info(**kwargs)

    def document_search_post(
        self,
        **kwargs
    ):
        """Search documents based on query and parameters  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.document_search_post(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            requester_uuid (UUIDString): [optional]
            user_roles (str): [optional]
            user_tenants (str): [optional]
            search_post_request (SearchPostRequest): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            SearchPostResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.document_search_post_endpoint.call_with_http_info(**kwargs)

    def document_vos(
        self,
        **kwargs
    ):
        """Get a serialized visualization of papers.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.document_vos(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            requester_uuid (UUIDString): [optional]
            user_roles (str): [optional]
            tenant (str): Tenant. [optional] if omitted the server will use the default value of "zetaalpha"
            query_string (QueryString): Query string. [optional]
            retrieval_method (str): Method used for retrieval. [optional] if omitted the server will use the default value of "keyword"
            year (YearRangeSchema): Limit results to those in year range (inclusive). [optional]
            sources ([str]): Limit results to selected sources. [optional]
            cited_by (str): Limit results to only papers cited by the given paper. [optional]
            cites (str): Limit results to only papers cite the given paper. [optional]
            authored_by (str): Limit results to only papers authored by the given person. [optional]
            date (DateRangeSchema): Limit results to those in date range (inclusive). [optional]
            doc_ids ([GUIDString]): Limit results to only the given document IDs. [optional]
            tag_ids ([str]): Limit results to only the given tag IDs. [optional]
            has_concept (str): Limit results to only papers that contain the given concept. [optional]
            with_content (bool): Limit results to only papers that have content (text representation). Note. This doesn't apply to private documents.. [optional] if omitted the server will use the default value of False
            include_default_filters (bool): Filter results based on the default filters configuration of the index.. [optional] if omitted the server will use the default value of True
            document_types ([str]): Limit results to documents with the given type. [optional] if omitted the server will use the default value of ["document"]
            sort (Sort1): Sorting parameters.. [optional]
            sort_order ([str]): Order in which to apply sorting parameters. All values from sort should be listed here.. [optional]
            similar_to ([UIDString]): Find documents similar to the list of input documents. [optional]
            collapse (str, none_type): Field on which to collapse results. [optional] if omitted the server will use the default value of "uid"
            rerank (bool): Whether we want to rerank seacrh results.. [optional] if omitted the server will use the default value of False
            rerank_top_n (int): A number of first results to re-rerank.. [optional] if omitted the server will use the default value of 30
            aggregate_reranked_results (bool): Aggregate lower-level units to higher-level ones.. [optional] if omitted the server will use the default value of False
            vos_size (int): Set the number of scientific items to visualize.. [optional] if omitted the server will use the default value of 1000
            with_code (bool): Output only papers with code.. [optional] if omitted the server will use the default value of False
            index_cluster (str): Human friendly name that specifies which index configuration to use during search. The way we convert this string into infrastructure configuration is part of the internal logic of this service. Ideally all possible values should be listed as part of another request along with the description of what each value means.  Currently, the value can be constructed by using knowledge of the index infrastructure. In particular, the value is separated by the `:` character. The part on the left of `:` represents the kubernetes namespace of the index cluster, while the part on the right specifies the infix in the index name.  For example, if a user wants to search in the index cluster located in the `foo` namespace and use the index named `my_tenant_bar_documents`, then the `index_cluster` value should be `foo:bar`. The user may also need to specify the retrieval unit and tenant as part of the request.  > Note: There's currently no endpoint for retrieving all valid values that the `index_cluster` parameter can take. . [optional]
            visibility ([str]): Filter documents by their visibility.. [optional]
            location_cities ([str]): Limit results to documents of authors located in cities. [optional]
            location_countries ([str]): Limit results to documents of authors located in countries. [optional]
            organizations ([str]): Limit results to documents of authors affiliated with organization. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.document_vos_endpoint.call_with_http_info(**kwargs)

    def document_vos_cluster_titles(
        self,
        **kwargs
    ):
        """Get a serialized visualization of papers with cluster titles.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.document_vos_cluster_titles(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            user_roles (str): [optional]
            tenant (str): Tenant. [optional] if omitted the server will use the default value of "zetaalpha"
            body ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.document_vos_cluster_titles_endpoint.call_with_http_info(**kwargs)

